﻿namespace CodeDDD.Application.Seedwork
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// The custom exception for validation errors
    /// </summary>
    public class ApplicationValidationErrorsException
        : Exception
    {
        #region Fields
        
        IEnumerable<string> _validationErrors;

        #endregion

        #region Properties

        /// <summary>
        /// Get or set the validation errors messages
        /// </summary>
        public IEnumerable<string> ValidationErrors
        {
            get
            {
                return _validationErrors;
            }
        }

        #endregion

        #region Constructor

        /// <summary>
        /// Create new instance of Application validation errors exception
        /// </summary>
        /// <param name="validationErrors">The collection of validation errors</param>
        public ApplicationValidationErrorsException(IEnumerable<string> validationErrors)
            : this("", validationErrors)
        {
        }

        /// <summary>
        /// Create new instance of Application validation errors exception
        /// </summary>
        /// <param name="validationErrors">The collection of validation errors</param>
        public ApplicationValidationErrorsException(string message, IEnumerable<string> validationErrors)
            : base(message)
        {
            _validationErrors = validationErrors;
        }

        #endregion
    }
}
